diff -rN -u old-cabal2arch/Main.hs new-cabal2arch/Main.hs
--- old-cabal2arch/Main.hs	2010-10-11 13:19:49.923426455 +0200
+++ new-cabal2arch/Main.hs	2010-10-11 13:19:49.940093138 +0200
@@ -571,6 +571,10 @@
     (text "build() {") 4
              (vcat $ (map text) (arch_build pkg))
    $$ char '}'
+ , hang
+    (text "package() {") 4
+             (vcat $ (map text) (arch_package pkg))
+   $$ char '}'
  ]
 
 --
@@ -629,28 +633,35 @@
 
     , arch_build =
         [ "cd ${srcdir}/" </> display name <-> display vers
-        , "runhaskell Setup configure --prefix=/usr --docdir=/usr/share/doc/${pkgname} || return 1"
-        , "runhaskell Setup build                   || return 1"
+        , "runhaskell Setup configure --prefix=/usr --docdir=/usr/share/doc/${pkgname}"
+        , "runhaskell Setup build"
         ] ++
+        -- Only needed for libraries:
+        (if hasLibrary
+           then
+            [ "runhaskell Setup haddock"
+            , "runhaskell Setup register   --gen-script"
+            , "runhaskell Setup unregister --gen-script"
+            ]
+           else [])
 
-    -- Only needed for libraries:
+    , arch_package = 
+        [ "cd ${srcdir}/" </> display name <-> display vers ] ++
+        -- Only needed for libraries:
         (if hasLibrary
            then
-            [ "runhaskell Setup haddock || return 1"
-            , "runhaskell Setup register   --gen-script || return 1"
-            , "runhaskell Setup unregister --gen-script || return 1"
-            , "install -D -m744 register.sh   ${pkgdir}/usr/share/haskell/$pkgname/register.sh"
+            [ "install -D -m744 register.sh   ${pkgdir}/usr/share/haskell/$pkgname/register.sh"
             , "install    -m744 unregister.sh ${pkgdir}/usr/share/haskell/$pkgname/unregister.sh"
             , "install -d -m755 $pkgdir/usr/share/doc/ghc/html/libraries"
             , "ln -s /usr/share/doc/${pkgname}/html ${pkgdir}/usr/share/doc/ghc/html/libraries/" ++ (display name)
             ]
            else [])
          ++
-         ["runhaskell Setup copy --destdir=${pkgdir} || return 1"]
+         ["runhaskell Setup copy --destdir=${pkgdir}"]
          ++
          (if not (null (licenseFile cabal)) && (case license cabal of GPL {} -> False; LGPL {} -> False; _ -> True)
           then
-              [ "install -D -m644 " ++ licenseFile cabal ++ " ${pkgdir}/usr/share/licenses/$pkgname/LICENSE || return 1"
+              [ "install -D -m644 " ++ licenseFile cabal ++ " ${pkgdir}/usr/share/licenses/$pkgname/LICENSE"
               , "rm -f ${pkgdir}/usr/share/doc/${pkgname}/LICENSE"
               ]
           else [])
